library(mvtnorm)

chiqutest <- function(X,As) ## X hat m Spalten und n Zeilen, As: Teilmenge an interessierenden Paaren inklusive Lags
{
pdach <- apply(X,2,mean)
#pdach <- c(0.01,0.01)
n <- length(X[,1])
m <- length(X[1,])
combi <- length(As[,1])
#pdach <- rep(0.5,m)
vector <- rep(0,combi)
for(k in 1:combi)
{
i <- As[k,1]
j <- As[k,2]
l <- As[k,3]
partone <- X[1:(n-l),i] - pdach[i]
parttwo <- X[(l+1):n,j] - pdach[j]
vector[k] <- sum(partone*parttwo)/sqrt(n)
}
#return(vector)
var <- pdach[1]*pdach[2]+pdach[1]^2*pdach[2]^2-pdach[1]^2*pdach[2]-pdach[1]^2*pdach[2]^2
teststatistic <- 0
if(var > 0) teststatistic <- vector^2 / var
return(teststatistic)
}

#set.seed(17072014)
#m <- 1000
#T <- 1000*2
#As=rbind(c(1,2,0),c(2,3,1))
#As=rbind(c(1,2,0),c(1,3,0),c(1,4,0),c(1,5,0),c(2,3,0),c(2,4,0),c(2,5,0),c(3,4,0),c(3,5,0),c(4,5,0))
#As=rbind(c(1,2,0),c(2,3,0),c(1,3,0))
#As <- matrix(c(1,2,0),ncol=3)
#counter <- rep(0,m)
#for(r in 1:m)
#{
#print(c(r,mean(counter)))
#X <- matrix(rbinom(T,1,0.05),ncol=2)
#pwert <- chiqutest(X,As)
#counter[r] <- pwert < 0.05
#}

## Simulationen

set.seed(20072014)
m <- 1000
nn <- c(250,500,1000,2000)
d <- 2
p <- 0.01
alpha <- 0.05
rhoarr <- 0
rhoo <- c(0,0.2,0.4,0.6,0.8)
As <- matrix(c(1,2,0),ncol=3)
counter <- matrix(0,ncol=length(rhoo),nrow=length(nn))
for(f in 1:length(nn))
{
n <- nn[f]
for(g in 1:length(rhoo))
{
print(counter)
rho <- rhoo[g]
sigma <- matrix(rho,ncol=d,nrow=d)
diag(sigma) <- rep(1,d)
zaehler <- rep(0,m)
for(i in 1:m)
{
print(mean(zaehler[1:i]))
x <- matrix(0,ncol=d,nrow=n)
#x <- t(apply(x,1,function(y) rmvnorm(1,rep(0,d),sigma1)))
#x <- matrix(0,ncol=d,nrow=n+1)
x <- t(apply(x,1,function(y) rmvnorm(1,rep(0,d),sigma)))
#x <- apply(x,2,function(x) filter(x,c(1,rhoar),"convolution"))
#x <- x[-(n+1),]
#x <- x < (qnorm(p)*sqrt(1+rhoar^2))
x <- apply(x,2,function(x) as.numeric(x < (qnorm(p))))
teststatistic <- chiqutest(x,As)
zaehler[i] <- teststatistic > qchisq(0.95,1)
}
counter[f,g] <- mean(zaehler)
}
}
write.table(counter,"Table 3.txt")